module I2C_Controller (
	input wire clock,
	output reg i2c_sclk,//I2C CLOCK
 	inout reg i2c_sdat,//I2C DATA
	input wire [23:0] i2c_data,//DATA:[SLAVE_ADDR,SUB_ADDR,DATA]
	input wire go,      //start transfer
	output reg ready,     //end transfer 
	output reg [6:0] sd_counter
);

reg sdo;
reg sclk;
reg [23:0]sd;

reg [10:0] cnt2;
reg oldclk2,clk2;

initial
  begin
  sclk=1;sdo=1; ready=1; oldclk2=0; cnt2=0; clk2=0; 
  sd_counter=127;
  end  

always 
  begin 
  i2c_sclk<=sclk;   
  i2c_sdat<=sdo;
  end
  
always @(posedge clock) 
  begin
  cnt2=cnt2+1;
  oldclk2=clk2;
  clk2=cnt2[1];  

  if (go==1)
    begin
    sd=i2c_data; 
	 sd_counter=0;
	 ready=0;
	 end
  else 
	 if (sd_counter >= 86) begin sdo=1; sclk=1; ready=1; end

  if ((clk2==1) && (oldclk2==0)) // posedge clk2
    begin
    if (sd_counter < 86) sd_counter=sd_counter+1;
    case (sd_counter)
	      0  : begin sdo=1; sclk=1; ready=0;end
	   //start
	      1  : begin sdo=0;end
	      2  : sclk=0;
	   //slave addr
	      3  : sdo=sd[23];
			4	: sclk=1;
			5	: sclk=0;
	      6  : sdo=sd[22];
			7	: sclk=1;
			8	: sclk=0;
	      9  : sdo=sd[21];
			10	: sclk=1;
			11	: sclk=0;
         12 : sdo=sd[20];
			13	: sclk=1;
			14	: sclk=0;
	      15 : sdo=sd[19];
			16	: sclk=1;
			17	: sclk=0;
	      18 : sdo=sd[18];
			19	: sclk=1;
			20	: sclk=0;
	      21 : sdo=sd[17];
			22	: sclk=1;
			23	: sclk=0;
	      24 : sdo=sd[16];	
			25	: sclk=1;
			26	: sclk=0;
	      27 : sdo=1'bz;//ACK
			28	: sclk=1;
			29	: sclk=0;
	   //sub addr
	      30 : sdo=sd[15]; 
			31	: sclk=1;
			32	: sclk=0;
	      33 : sdo=sd[14];
			34	: sclk=1;
			35	: sclk=0;
	      36 : sdo=sd[13];
			37	: sclk=1;
			38	: sclk=0;
	      39 : sdo=sd[12];
			40	: sclk=1;
			41	: sclk=0;
	      42 : sdo=sd[11];
			43	: sclk=1;
			44	: sclk=0;
	      45 : sdo=sd[10];
			46	: sclk=1;
			47	: sclk=0;
	      48 : sdo=sd[9];
			49	: sclk=1;
			50	: sclk=0;
	      51 : sdo=sd[8];
			52	: sclk=1;
			53	: sclk=0;
	      54 : sdo=1'bz;//ACK
			55	: sclk=1;
			56	: sclk=0;
   	//data
	      57 : sdo=sd[7]; 
			58	: sclk=1;
			59	: sclk=0;
	      60 : sdo=sd[6];
			61	: sclk=1;
			62	: sclk=0;
	      63 : sdo=sd[5];
			64	: sclk=1;
			65	: sclk=0;
	      66 : sdo=sd[4];
			67	: sclk=1;
			68	: sclk=0;
	      69 : sdo=sd[3];
			70	: sclk=1;
			71	: sclk=0;
	      72 : sdo=sd[2];
			73	: sclk=1;
			74	: sclk=0;
	      75 : sdo=sd[1];
			76	: sclk=1;
			77	: sclk=0;
	      78 : sdo=sd[0];
			79	: sclk=1;
			80	: sclk=0;
	      81 : sdo=1'bz;
			82	: sclk=1;
			83	: sclk=0;
  	   //stop
         84 : begin sdo=1'b0; sclk=1'b0; end	
         85: sclk=1'b1; 
         86: begin sdo=1'b1; ready=1; end 
      endcase
    end
  end

endmodule
