module audiobuf (clk, datain,dataaddr,datastb,left,right,audiostb,empty);

// Audio buffer for de2-115 and the Propeller verilog with portb enabled
// v20140814-2029
// Piotr Kardasz, pik33@o2.pl
// GPL 3.0 when using with the Propeller Verilog code
// MIT elsewhere
// Warning: beta quality code, no warranty, use at your own risk

input wire clk;
input wire [31:0] datain;
input wire [7:0] dataaddr;
input wire datastb;
output reg [23:0] left;
output reg [23:0] right;
input wire audiostb;
output reg [1:0] empty;

reg [31:0] buff [256];
reg [31:0] adata;
reg [7:0] aaddr;
reg oldaudiostb;
reg olddatastb;

initial
  begin
  $readmemh("sinus.hex",buff);
  aaddr<=0;
  empty<=0;
  end
  
  
 always@(posedge clk)
   begin
	oldaudiostb<=audiostb; 
	olddatastb<=datastb;

	  
   if ((audiostb==1) && (oldaudiostb==0)) // posedge audiostb
	  begin
     adata<=buff[aaddr];
     aaddr<=aaddr+1;
     if (aaddr==128) empty[0]<=1;
     if (aaddr==0) empty[1]<=1;
	  left<={adata[31:16],8'h00};
	  right<={adata[15:0],8'h00};
	  oldaudiostb<=audiostb;
	  end
	  
	if (datastb==1)// && (olddatastb==0)) // posedge datastb
	  begin
     buff[dataaddr]<=datain;
	  if(dataaddr<128) empty[0]<=0; else empty[1]<=0;
	  olddatastb<=datastb;
	  end  
	end  
	
endmodule	